include "Zeropage.inc"
include "Vram.inc"
include "Chars.inc"

ext FortPattern_
ext FortY_
ext CurrentCharRam

Width equ 6
Height equ 6+1
PatternOffset equ (Char_Fort and $7f)*CharHeight

pDestination equ ZW0
pSource equ ZW1
yMod equ ZB0
xCount equ ZB1
yCount equ ZB2
sourceOffset equ ZB3
destinationOffset equ ZB4

; void SetFortPattern();
cseg
ClearX:
    lda #0
    ldy <destinationOffset
    cpx #0
    do
    while ne
        sta (<pDestination),y | iny
        dex
    wend
    sty <destinationOffset
rts

CopyX:
    do
        ldy <sourceOffset
        lda (<pSource),y | iny
        sty <sourceOffset

        ldy <destinationOffset
        sta (<pDestination),y | iny
        sty <destinationOffset

        dex
    while ne | wend
rts

SetFortPattern_: public SetFortPattern_
    pha
        lda #low FortPattern_ | sta <pSource
        lda #high FortPattern_ | sta <pSource+1

        lda #low PatternOffset | sta <pDestination
        lda #high PatternOffset |clc|adc CurrentCharRam | sta <pDestination+1

        lda FortY_ | and #7 | sta <yMod

        lda #0 | sta <sourceOffset | sta <destinationOffset
        lda #Width | sta <xCount
        do
            ldx <yMod
            jsr ClearX

            lda <sourceOffset
            pha
                lda #CharHeight | sec|sbc <yMod | tax
                jsr CopyX
            pla
            clc|adc #CharHeight | sta <sourceOffset

            dec <xCount
        while ne | wend
        lda <pDestination | clc|adc #CharHeight*Width | sta <pDestination
        lda <pDestination+1 | adc #0 | sta <pDestination+1
        ldy #0 | sty <destinationOffset

        lda #Height-2 | sta yCount
        do
            lda #CharHeight | sec|sbc <yMod | sta <sourceOffset
            lda #Width | sta <xCount
            do
                ldx <yMod
                if ne
                    jsr CopyX
                endif
                lda <sourceOffset
                clc|adc #CharHeight*(Width-1) | sta <sourceOffset
                lda #CharHeight | sec|sbc <yMod | tax
                jsr CopyX
                lda <sourceOffset | sec|sbc #CharHeight*(Width-1) | sta <sourceOffset
                dec <xCount
            while ne | wend
            lda <pSource | clc|adc #CharHeight*Width | sta <pSource
            lda <pSource+1 | adc #0 | sta <pSource+1

            lda <pDestination | clc|adc #CharHeight*Width | sta <pDestination
            lda <pDestination+1 | adc #0 | sta <pDestination+1
            ldy #0 | sty <destinationOffset
            
            dec yCount
        while ne | wend

        lda #CharHeight | sec|sbc <yMod | sta <sourceOffset
        lda #Width | sta <xCount
        do
            ldx <yMod
            if ne
                lda <sourceOffset
                pha
                    jsr CopyX
                pla
                clc|adc #CharHeight | sta <sourceOffset
            endif
            lda #CharHeight | sec|sbc <yMod | tax
            jsr ClearX
            dec <xCount
        while ne | wend
    pla
rts
