#include "Sprite.h"
#include "Ground.h"
#include "GroundEnemy.h"
#include "Sound.h"
#include "Bang.h"
#include "Status.h"

constexpr byte Size = 1 * CoordRate;
constexpr byte RangeY = StageHeight * CoordRate;
constexpr byte InvalidY = 0xff;

static const word[] Points = { 3, 5 };

constexpr byte Count = Sprite_BarrierHead - Sprite_GroundEnemy;
GroundEnemy[Count] GroundEnemies;

static void End(ptr<GroundEnemy> pEnemy)
{
    pEnemy->y = InvalidY;
    HideSprite(pEnemy->sprite);
}


static void Destroy(ptr<GroundEnemy> pEnemy)
{
    Sound_SmallBang();
    StartBang(pEnemy->x + Size, pEnemy->y + Size, false);
    End(pEnemy);
    AddScore(Points[pEnemy->type]);
}


bool HitBulletGroundEnemy(byte x, byte y)
{
    ptr<GroundEnemy> pEnemy;
    x += CoordRate - 1;
    for (pEnemy : GroundEnemies) {
        if (pEnemy->y >= RangeY) continue;
        if (
            x >= pEnemy->x && x < pEnemy->x + CoordRate * 2 &&
            y >= pEnemy->y && y < pEnemy->y + CoordRate * 2
        ) {
            Destroy(pEnemy);
            return true;    
        }
    }
    return false;
}
