constexpr ptr<byte> Vram0 = (ptr<byte>)0x0800;
constexpr ptr<byte> Vram1 = (ptr<byte>)0x0c00;
constexpr ptr<byte> CharRam0 = (ptr<byte>)0x1000;
constexpr ptr<byte> CharRam1 = (ptr<byte>)0x1400;
constexpr ptr<byte> PlayerRam0 = (ptr<byte>)0x1800;
constexpr ptr<byte> PlayerRam1 = (ptr<byte>)0x2000;

constexpr ptr<byte> Vram = Vram0;
constexpr byte VramWidth = 32;
constexpr byte VramHeight = 24;
constexpr byte CharHeight = 8;
constexpr byte PatternSize = CharHeight;
constexpr word VramRowSize = VramWidth;
constexpr byte VramStep = 1;

extern void VVramToVram();
extern void ClearScreen();
extern ptr<byte> Put(ptr<byte> pVram, byte c);
extern ptr<byte> PrintC(ptr<byte> pVram, byte c);

extern void SetPatternMono(ptr<byte> pSource, byte pattern, byte color, byte count);
// extern void SetPatternColor(ptr<byte> pSource, byte pattern, byte count);

extern void InitPage();
extern ptr<byte> VramPtr(byte x, byte y);
extern void GroundToVram();
extern void SwitchVram();
extern void SwitchChars();
extern void StatusToVram();
extern void SetFortPattern();
extern void InitBarrierPattern();

extern void InitVram();
extern void DrawAll();