include "Atari5200.inc"
include "Zeropage.inc"
include "Vram.inc"
include "Chars.inc"

ext DisplayList0,DisplayList1
ext Status_

pDestination equ ZW0
pSource equ ZW1

dseg
CurrentVram: public CurrentVram
    defb 0
CurrentCharRam: public CurrentCharRam
    defb 0


; void ClearScreen();
cseg
Clear1:
    ldx #VramHeight
    do
        lda #Char_Space
        ldy #0
        do
            sta (<pDestination),y
            iny
            cpy #VramWidth
        while ne | wend

        lda <pDestination | clc | adc #low VramWidth | sta <pDestination
        lda <pDestination+1 | adc #high VramWidth | sta <pDestination+1
        dex
    while ne | wend
rts
ClearScreen_: public ClearScreen_
    pha
        lda #low Vram0 | sta <pDestination
        lda #high Vram0 | sta <pDestination+1
        jsr Clear1
        lda #low Vram1 | sta <pDestination
        lda #high Vram1 | sta <pDestination+1
        jsr Clear1
    pla
rts


; ptr<byte> VramPtr(byte x, byte y);
dseg
VramPtr_@Param0: public	VramPtr_@Param0
VramPtr_.x_:	defs 1
VramPtr_@Param1: public	VramPtr_@Param1
VramPtr_.y_:	defs 1
cseg
VramPtr_: public VramPtr_
	pha
        lda	VramPtr_.y_
        asl a | asl a | asl a  ;*8
        sta <pDestination | lda #0 | sta <pDestination+1
        asl <pDestination | rol <pDestination+1 ;16
        asl <pDestination | rol <pDestination+1 ;32
        lda VramPtr_.x_ | clc | adc <pDestination | sta <pDestination
        lda <pDestination+1 | adc #0 | sta <pDestination+1
        ldy <pDestination
        lda <pDestination+1 | clc|adc CurrentVram | tax
	pla
rts


Put1:
    tax
    ldy #0
    sta (<pDestination),y
    lda <pDestination+1
    pha
        clc|adc #high Vram1-high Vram0 | sta <pDestination+1
        txa
        sta (<pDestination),y
    pla
    sta <pDestination+1
rts

; ptr<byte> Put(ptr<byte> pVram, byte c);
dseg
Put_@Param0: public Put_@Param0
Put_.pVram_:	defs 2
Put_@Param1: public Put_@Param1
Put_.c_:	defs 1
cseg
Put_: public Put_
    pha
        lda Put_@Param0 | sta <pDestination
        lda Put_@Param0+1 | sta <pDestination+1
        lda Put_.c_
        jsr Put1
        lda <pDestination | clc|adc #1 | tay
        lda <pDestination+1 | adc #0 | tax
    pla
rts


; ptr<byte> PrintC(ptr<byte> pVram, byte c);
dseg
PrintC_@Param0: public PrintC_@Param0
PrintC_.pVram_:	defs 2
PrintC_@Param1: public PrintC_@Param1
PrintC_.c_:	defs 1
cseg
CharTable:
    defb '-0123456789ABCEGHIMNOPRSTUV'
PrintC_: public PrintC_
    pha
        lda PrintC_.c_
        ldx #0
        do
            cmp CharTable,x
            beq PrintC_exit
            inx
            cpx #27
        while ne | wend
        ldx #Char_Space
        jmp PrintC_skip
        PrintC_exit:
        txa | ora #$80 | tax
        PrintC_skip:
        lda PrintC_@Param0 | sta <pDestination
        lda PrintC_@Param0+1 | sta <pDestination+1
        txa
        jsr Put1
        lda <pDestination | clc|adc #1 | tay
        lda <pDestination+1 | adc #0 | tax
    pla
rts


; void StatusToVram();
cseg
StatusToVram_: public StatusToVram_
    pha
        lda CurrentVram | sta <pDestination+1
        ldy #0 | sty <pDestination
        do
            lda Status_,y
            cmp #Char_Space
            if ne
                ; txa            
                sta (<pDestination),y
            endif
            iny
            cpy #VramWidth*2
        while ne | wend
    pla
rts
