include "Atari5200.inc"
include "Zeropage.inc"
include "Vram.inc"
include "Chars.inc"
include "Stage.inc"

ext DisplayList0,DisplayList1
ext CurrentVram, CurrentCharRam
ext dotOffset_, Ground_
ext FortY_
ext CHBAS

pDestination equ ZW0
pSource equ ZW1
yCount equ ZB0

; void InitPage();
cseg
InitPage_: public InitPage_
    pha
        lda #high Vram1 | sta CurrentVram
        lda #high CharRam1 | sta CurrentCharRam

        lda #low DisplayList0 | sta SDLSTL
        lda #high DisplayList0 | sta SDLSTH
        lda #high CharRam0 | sta CHBAS
    pla
rts


; void GroundToVram();
cseg
GroundToVram_: public GroundToVram_
    pha
        lda #low (Ground_+StageWidth*4) | sta <pSource
        lda #high (Ground_+StageWidth*4) | sta <pSource+1

        lda #0 | sta <pDestination
        lda CurrentVram | sta <pDestination+1
        ldx #VramHeight
        do
            ldy #0
            do
                lda (<pSource),y | sta (<pDestination),y
                iny
                cpy #StageWidth
            while ne | wend
            lda <pSource | clc|adc #StageWidth | sta <pSource
            lda <pSource+1 | adc #0 | sta <pSource+1

            lda <pDestination | clc|adc #VramWidth | sta <pDestination
            lda <pDestination+1 | adc #0 | sta <pDestination+1
            dex
        while ne | wend
    pla
rts


; void SwitchVram();
cseg
SwitchVram_: public SwitchVram_
    pha
        lda CurrentVram
        cmp #high Vram0
        if eq
            lda #high Vram1 | sta CurrentVram
            lda #low DisplayList0 | sta SDLSTL
            lda #high DisplayList0 | sta SDLSTH
        else
            lda #high Vram0 | sta CurrentVram
            lda #low DisplayList1 | sta SDLSTL
            lda #high DisplayList1 | sta SDLSTH
        endif
    pla
rts


; void SwitchChars();
cseg
SwitchChars_: public SwitchChars_
    pha
        lda CurrentCharRam
        cmp #high CharRam0
        if eq
            lda #high CharRam1 | sta CurrentCharRam
            lda #high CharRam0 | sta CHBAS
        else
            lda #high CharRam0 | sta CurrentCharRam
            lda #high CharRam1 | sta CHBAS
        endif
    pla
rts


; void InitBarrierPattern();
cseg
InitBarrierPattern_: public InitBarrierPattern_
    pha
        lda #8 | sta <yCount
        ldx #0
        do
            lda #0
            ldy <yCount
            do
                cpy #8
            while ne
                sta CharRam0+(Char_Barrier and $7f)*CharHeight,x | inx
                iny
            wend
            lda #$ff
            sta CharRam0+(Char_Barrier and $7f)*CharHeight,x | inx
            lda #0
            ldy <yCount
            do
                dey
            while ne
                    sta CharRam0+(Char_Barrier and $7f)*CharHeight,x | inx
            wend
            dec <yCount
        while ne | wend
    pla
rts
